#include <windows.h>
#include <string.h>
#include "exports.h"
#include "cwstart.h"

LIBMAIN

/* Exported functions */
void DLL MoveToDelimetedCol(long colNum, LPSTR delim);
void DLL MoveToTabCol(long colNum);

/*************************************************************************/
/* _init(): Initialize this add-on when it's loaded                      */
/*************************************************************************/
void DLL 
_init()
{
	static BOOL firstTime = TRUE;

	if (firstTime) {
		/* Export all new Codewright API functions */
		LibExport("MoveToDelimetedCol long LPSTR");
		LibExport("MoveToTabCol long");

		firstTime = FALSE;
	}
}

void DLL MoveToDelimetedCol(long colNum, LPSTR delim)
{
	LPSTR line;
	long pos;
	long col;
	long ofs;

	if ((BufQCurrentBuffer() == 0) || (strlen(delim) == 0))
		return;

	MovHome();
	ofs = BufQOffset();
	line = BufReadStr(1000000);
	pos = 0;
	col = 1;
	while ((col != colNum) && (line[pos] != '\0')) {
		pos++;
		if (line[pos] == delim[0])
			col++;
	}
	if (col == colNum) {
		MovToOffset(ofs + pos + 1);
	}
	StrFree(line);
}

void DLL MoveToTabCol(long colNum)
{
	MoveToDelimetedCol(colNum, "\t");
}